      program forcing2munk
c
C=========================================================================
C=       TRANSFORMATION DU FICHIER ASCII "Fm_Q1QRlsQ2ls" EN FICHIER      =
C=         A ACCES DIRECT, contenant Q1 et Q2, LISIBLE PAR MUNK ET GRADS =
C=========================================================================
c
c  Variables :
c  ----------
c   nl       : nombre de niveaux des donnees
c   7        : nombre de pas de temps de la future simulation
c   u_eucrem : numero d'unite d'ecriture
c   z        : altitude
c   hTpot    : tendance de temperature potentielle
c   hQ       : tendance de rapport de melange
c   hw       : vitesse verticale
c   P        : pression
c
c   Parameters :
c   -----------
c   nl       : dimension de la grille
c   nbeuc    : nombre de pas de temps des donnees
c   ifrst    : nombre de duplicata du premier pas, ajoutes en tete
c
c----------------------------------------------------------------------
c Modifications :
c                        JYG (17/09/99)
c   Pas de temps du fichier de sortie fixe a la moitie de celui d'entree.
c   Un systeme lineaire est resolu de telle sorte que les valeurs moyennes
c   des diverses grandeurs sur chaque pas de temps soient les valeurs d'entree.
c     Le profil temporel des grandeurs est suppose constitue de segments de
c   droites dont les extremites sont aux milieux des pas de temps, sauf pour
c   le premier (qui part de 0) et le dernier (qui arrive en nbeuc).
c
c   Le systeme donnant les valeurs y aux milieux des pas de temps est
c   (en designant par mu_i la valeur moyenne (entree) sur le pas i) :
c             y_1 = mu_1
c             y_nbeuc = mu_nbeuc
c             6*y_i + y_(i-1) + y_(i+1) = 8*mu_i   (i = 2,nbeuc-1)
c
c   Les 2*nbeuc+1 valeurs z_i aux limites et milieux des pas sont donnees par :
c             z_1 = (3*y_1-y_2)/2
c             z_(2*nbeuc+1) = (3*y_nbeuc-y_(nbeuc-1))/2
c             z_2i = y_i                           (i = 2,nbeuc)
c             z_(2i+1) = (y_i+y_(i+1))/2           (i = 2,nbeuc-1)
c
c   Tous ces calculs sont faits dans le sous-programme av2inst.
c---------------------------------------------------------------------
c
      character*5 string
      integer klon,u_eucrem
      parameter (klon=1,u_eucrem=33)
      integer nl,nbeuc
      integer u_hapex
      parameter (nll=100)
      parameter (ifrst = 0, ifrstp1 = ifrst+1)
      parameter (nl=43,nbeuc=40,nbeucpf=nbeuc+ifrst,nbeuc2=2*nbeuc+1)
      parameter (nlFm=48)        ! dimensions dans le fichier de forcage
      integer icomp
      real htpot_fm(nlFm,nbeuc),hQ_fm(nlFm,nbeuc)
     *    ,hw_fm(nlFm,nbeuc)
     *    ,hThTur_fm(nlFm,nbeuc),hqTur_fm(nlFm,nbeuc)
     *    ,Q1_fm(nlFm,nbeuc), Q2_fm(nlFm,nbeuc)
      real z(nl),htpot(nl,nbeucpf),hQ(nl,nbeucpf)
     *    ,hThTur(nl,nbeucpf),hqTur(nl,nbeucpf)
     $    ,hw(nl,nbeucpf),p(nl),hU(nl,nbeucpf),hV(nl,nbeucpf)
     *    ,Q1(nl,nbeucpf), Q2(nl,nbeucpf)
      real SQ1(nbeucpf), SQ2(nbeucpf)
      real Sht(nbeucpf), Shq(nbeucpf)
      real hTpot2(nl,nbeuc2),hQ2(nl,nbeuc2)
     *    ,hThTur2(nl,nbeuc2),hqTur2(nl,nbeuc2)
     $    ,hw2(nl,nbeuc2),hU2(nl,nbeuc2),hV2(nl,nbeuc2)
     *    ,Q12(nl,nbeuc2), Q22(nl,nbeuc2)
      real SQ12(nbeuc2), SQ22(nbeuc2)
      real Sht2(nbeuc2), Shq2(nbeuc2)
      real yy(nl,nbeucpf)
      real ps(nbeuc),zz(nl,nbeuc),u(nl,nbeuc),v(nl,nbeuc)
     $    ,Temp(nl,nbeuc),Q(nl,nbeuc),PP(nl,nbeuc),PH(nl,nbeuc)
c
      character*5 string_tur
      data string_tur/'q-Tur'/
c
      character *5 s1
      character *2 s2
      character *1 s3
      character *7 s4
c
      do k=1,nl
          do i = 1,nbeucpf
            hU(k,i) = 0.
            hV(k,i) = 0.
            hW(k,i) = 0.
          enddo
          do i = 1,nbeuc2
            hU2(k,i) = 0.
            hV2(k,i) = 0.
            hW2(k,i) = 0.
          enddo
      enddo

c
      open(22,file='Fm_Q1QRlsQ2ls',form='formatted')
      open(23,file='Fm_AltRR.dat',form='formatted')   ! date
      open(25,file='Fm_TurbThRv',form='formatted')    ! tendance turbulente
      open(26,file='Fm_UVWThRv.dat',form='formatted') ! profils
c
c--    Read file 22 : nstep
c
      read (22,*) s1
      read (22,*) s1
      read (22,*) s1,s2,s3,s4,nstep
      print *, ' nbre de pas de temps : ',nstep
      IF (s3 .NE. 'I')  THEN
        print *,' mvs fichier 22 ; trouve ',s3,
     $          ' au lieu de I'
        stop
      ENDIF
      nsteppf=nstep+ifrst
      nstep2=2*nstep+1
c
50    continue
      do i=1,1000
        read(22,1000,end=200) string
1000    format (a5)
        print *, string
ccc        if (string .eq. 'Theta') go to 100
ccc        if (string .eq. 'Rv LS') go to 110
ccc        if (string .eq. 'U-Mom') go to 112
ccc        if (string .eq. 'V-Mom') go to 114
ccc        if (string .eq. 'VERTI') go to 120
        if (string .eq. 'Q1(co') go to 122
        if (string .eq. 'Q2(g/') go to 124
      enddo
      go to 50
c
c     
100   continue
500   format(f8.2,7e10.3)
      print *,' Lecture des donnees hTpot'
      call Fmread(22,hTpot_fm,nlfm,nstep)   ! Theta LS forcing (K/hr)
      print *, ' hTpot_fm'
      print *, hTpot_fm
      do k=1,nl
          do i = 1,nstep
            hTpot(k,i) = hTpot_fm(k+1,i)/3600.
          enddo
      enddo
c
      call av2inst(hTpot,yy,hTpot2,nl,nsteppf,nl)
c
      print *, ' hTpot2'
      print *, hTpot2
      go to 50
 1001   format(f8.2,7(1X,E9.3))
c
110   continue
      print *,' Lecture des donnees hQ'
      call Fmread(22,hQ_fm,nlfm,nstep)   ! Rv LS forcing (g/kg/hr)
      do k=1,nl
          do i = 1,nstep
            hQ(k,i) = hQ_fm(k+1,i)/3600./1000.
          enddo
      enddo
c
      call av2inst(hQ,yy,hQ2,nl,nsteppf,nl)
c
      go to 50
c
112   continue
      print *,' Lecture des donnees hU'
      do k=1,nl
          do i = 1,nstep
            hU(k,i) = 0.
          enddo
      enddo
c
      call av2inst(hU,yy,hU2,nl,nsteppf,nl)
c
      go to 50
c
114   continue
      print *,' Lecture des donnees hV'
      do k=1,nl
          do i = 1,nstep
            hV(k,i) = 0.
          enddo
      enddo
c
      call av2inst(hV,yy,hV2,nl,nsteppf,nl)
      print *,'  TEST !!!! hV2 '
      print *,hv2
      print *,' FIN TEST !!!! ' 
c
      go to 50
c
122   continue
      print *,' Lecture des donnees Q1'
      call Fmread(22,Q1_fm,nlfm,nstep)   ! Q1 (K/hr)
c
      do k=1,nl
          do i = 1,nstep
            Q1(k,i) = Q1_fm(k+1,i)
          enddo
      enddo
c
c      Attention : le chauffage Q1 est une integrale pendant un pas de temps.
c                                      
c
      call av2inst(Q1,yy,Q12,nl,nsteppf,nl)
c
      print *, ' Q12 ',Q12
c
      go to 50
c
124   continue
      print *,' Lecture des donnees Q2'
      call Fmread(22,Q2_fm,nlfm,nstep)   ! Q2 (K/hr)
c
      do k=1,nl
          do i = 1,nstep
            Q2(k,i) = Q2_fm(k+1,i)
          enddo
      enddo
c
c      Attention : l'assechement Q2 est une integrale pendant un pas de temps.
c                                      
c
      call av2inst(Q2,yy,Q22,nl,nsteppf,nl)
c
      print *, ' Q22 ',Q22
c
      go to 50
c
200   continue
      close (22)
c
c--    Read file 26 : vitesse verticale
c
      do i=1,1000
        read(26,1000,end=250) string
        print *, string
        if (string .eq. 'W(m/s') go to 120
      enddo
c
120   continue
      print *,' Lecture des donnees hw'
      call Fmread(26,hW_fm,nlfm,nstep)   ! Vitesse verticale (m/s)
c
      do k=1,nl
          do i = 1,nstep
            hW(k,i) = hW_fm(k+1,i)
          enddo
      enddo
c
c      Attention : on met la vitesse verticale dans hw et non sa tendance.
c      Il s'agit de valeurs instantannees : il ne faut pas appeler av2inst.
c
      do k=1,nl
          do i = 1,nstep-1
            hW2(k,2*i-1) = hW(k,i)
            hW2(k,2*i) = 0.5*(hw(k,i)+hw(k,i+1))
          enddo
            hw2(k,2*nstep-1) = hw(k,nstep)
            hw2(k,2*nstep)   = hw(k,nstep)
      enddo

c
      print *, ' hw2 ',hw2
c
c
250   continue
      close (26)
c
c--    Read file 23 : date
13    read(23,1000,end=91) string
      print *, string
      IF (string .eq. 'Altit') go to 132
      IF (string .ne. 'Preci') go to 13
c
      read(23,1000,end=90) string
      read(23,1000,end=90) string
      read(23,1000,end=90) string
      read(23,*,end=90) itime,time
      ihour = time/3600.
      go to 130
c
132   read(23,*,end=90) s1,s2,psol
      go to 13
c
91    print *, 'mauvais fichier 23'
      stop
c
130   close (30)
c
c--    Read file 25 : tendances turbulentes
14    read(25,1000,end=90) string
      print *, string
      IF (string .ne. 'T-Tur') go to 14
c
      call Fmread(25,hThTur_fm,nlfm,nstep)
c
c      Facteur 1/3600 pour passer de K/h  K/s
      do k=1,nl
          do i = 1,nstep
            hThTur(k,i) = hThTur_fm(k+1,i)/3600.
          enddo
      enddo
c
      call av2inst(hThTur,yy,hThTur2,nl,nsteppf,nl)
c
c
15    read(25,1000,end=90) string
      print *, string
      IF (string .ne. 'q-Tur') go to 15
c
      call Fmread(25,hqTur_fm,nlfm,nstep)
c
c      Facteur 1/(3600*1000) pour passer de g/kg/h  (kg/kg/s)
      do k=1,nl
          do i = 1,nstep
            hqTur(k,i) = hqTur_fm(k+1,i)/3600./1000.
          enddo
      enddo
c
      call av2inst(hqTur,yy,hqTur2,nl,nsteppf,nl)
c
c
      go to 102
90    print *, 'mauvais fichier 25'
      stop
c
102   continue

c
c--    Lecture de la grille, de u et de v
c
      u_hapex = 21
      open(u_hapex,file='hapex.dat',form='unformatted',
     .              access='direct',recl=klon*4)
       icomp=0
       call rdgrads(u_hapex,icomp,nl,ps,zz,
     $          u,v,Temp,Q,PP,PH)
       do k=1,nl
         z(k) = zz(k,1)
         P(k) = PP(k,1)/100.
       enddo
c
      close(u_hapex)
c
c--    Correction de Q1.
c--    Sortie des integrales verticales de Q1 et Q2.
c--    Sortie des integrales verticales des tendances turbulentes
c
      rg = 9.81
      rkappa = 1./3.5
      do i=1,nstep
         do k=1,nl
          Q1(k,i) = Q1(k,i)*(P(k)/1000.)**rkappa
         enddo
      enddo
      do i=1,nstep2
         do k=1,nl
          Q12(k,i) = Q12(k,i)*(P(k)/1000.)**rkappa
         enddo
      enddo
      do i=1,nstep
         SQ1(i) = 0.
         SQ2(i) = 0.
         Sht(i) = 0.
         Shq(i) = 0.
         deltaP= psol- 100.*(P(1)+P(2))/2.
         do k=1,nl-1
c          SQ1 et SQ2 en kg/m2/h
c    Facteur (Cp/Lv) dans SQ1 pour passer de K/h  kg/kg/h
c    Facteur 1/1000. dans SQ2 pour passer de g/kg/h  kg/kg/h
          SQ1(i) = SQ1(i) + (1./rg)*deltaP*Q1(k,i)/2500.
          SQ2(i) = SQ2(i) + (1./rg)*deltaP*Q2(k,i)/1000.
c          Sht en W/m2 ; facteur Cp pour passer de K/s  W/kg
          Sht(i) = Sht(i) + 
     $      (1./rg)*deltaP*hThTur(k,i)*1000.*(P(k)/1000.)**rkappa
c          Shq en kg/m2/s
          Shq(i) = Shq(i) + (1./rg)*deltaP*hqTur(k,i)
          IF (k.LT.nl-1) deltaP = 100.*(P(k) - P(k+2))/2.
         enddo
      enddo
      do k=1,nl
          do i = 1,nstep-1
            SQ12(2*i-1) = SQ1(i)
            SQ12(2*i) = 0.5*(SQ1(i)+SQ1(i+1))
            SQ22(2*i-1) = SQ2(i)
            SQ22(2*i) = 0.5*(SQ2(i)+SQ2(i+1))
            Sht2(2*i-1) = Sht(i)
            Sht2(2*i) = 0.5*(Sht(i)+Sht(i+1))
            Shq2(2*i-1) = Shq(i)
            Shq2(2*i) = 0.5*(Shq(i)+Shq(i+1))
          enddo
            SQ12(2*nstep-1) = SQ1(nstep)
            SQ12(2*nstep)   = SQ1(nstep)
            SQ22(2*nstep-1) = SQ2(nstep)
            SQ22(2*nstep)   = SQ2(nstep)
            Sht2(2*nstep-1) = Sht(nstep)
            Sht2(2*nstep)   = Sht(nstep)
            Shq2(2*nstep-1) = Shq(nstep)
            Shq2(2*nstep)   = Shq(nstep)
      enddo
      print 1789, (i,SQ1(i),SQ2(i), i=1,nstep)
1789  Format (' Integ. de Q1 et de Q2 ',i2,1x,f10.2,1x,f10.2)
c
      open(u_eucrem,file='q1q2.dat',form='unformatted',
     .              access='direct',recl=klon*4)
c
      print *,' Ecriture '
      icomp=0
      do i=1,nstep2
cc         ii=min((i+1)/2,nstep)
         do k=1,nl
            icomp=icomp+1
            write(u_eucrem,rec=icomp)(z(k))
         enddo
         do k=1,nl
            icomp=icomp+1
            write(u_eucrem,rec=icomp)(Q12(k,i))
         enddo
         do k=1,nl
            icomp=icomp+1
            write(u_eucrem,rec=icomp)(Q22(k,i))
         enddo
         do k=1,nl
            icomp=icomp+1
            write(u_eucrem,rec=icomp)(hw2(k,i))
         enddo
         icomp = icomp+1
cc          write(u_eucrem,rec=icomp)(SQ1(ii))
          write(u_eucrem,rec=icomp)(SQ12(i))
          print *,' i,SQ12(i) ',i,SQ12(i)
         icomp = icomp+1
cc          write(u_eucrem,rec=icomp)(SQ2(ii))
          write(u_eucrem,rec=icomp)(SQ22(i))
          print *,' i,SQ22(i) ',i,SQ22(i)
         icomp = icomp+1
cc          write(u_eucrem,rec=icomp)(Sht(ii))
          write(u_eucrem,rec=icomp)(Sht2(i))
         icomp = icomp+1
cc          write(u_eucrem,rec=icomp)(Shq(ii))
          write(u_eucrem,rec=icomp)(Shq2(i))

      enddo
      print *,' Ecriture terminee '
c
      close(u_eucrem)
      
c
      open(99,file='q1q2.ctl',form='formatted')
          write(99,'("DSET ^q1q2.dat")')
          write(99,'("UNDEF 1.0E+30")')
          write(99,'("TITLE ligne de grain forcage Lscale")')
          write(99,'("XDEF 1 LEVELS 0.0")')
          write(99,'("YDEF 1 LEVELS 0.0")')
          write(99,'("ZDEF",1x,i2,2x,"LEVELS",/(4f10.3))')
     .                     nl ,(P(k),k=1,nl)
          write(99,'("TDEF",2x,i2,2x,"LINEAR",2x,i2,
     .               "Z21AUG1992  10MN")')
     .                nstep2,ihour
          write(99,'("VARS        8")')
          write(99,'("zz     ",2x,i3,2x,"99",2x,
     .               "altitude")')(nl)
          write(99,'("Q1      ",2x,i3,2x,"99",2x,
     .               "Source apparente de chaleur (K/h)")')nl
          write(99,'("Q2      ",2x,i3,2x,"99",2x,
     .               "Puits apparent d humidite (K/h)")')nl
          write(99,'("hw      ",2x,i3,2x,"99",2x,
     .               "tendance de la vitesse verticale")')nl
          write(99,'("SQ1         0  99",2x,
     .               "integrale de Q1 sur la verticale")')
          write(99,'("SQ2         0  99",2x,
     .               "integrale de Q2 sur la verticale")')
          write(99,'("Sht         0  99",2x,
     .               "integrale de htTurb sur la verticale")')
          write(99,'("Shq         0  99",2x,
     .               "integrale de hqTurb sur la verticale")')
          write(99,'("ENDVARS")')
      close(99)
                          
      print*,'hello'
c
      stop
 999  print *,'erreur lecture des donnees ',string,kj
      stop
      end
      subroutine av2inst(amu,y,z,l,n,nll)
      dimension amu(nll,2),y(nll,2),z(nll,2)
      dimension alfa(1000)
c
      do k = 1,l                      ! boucle sur les niveaux
c
c 1. Inversion : amu -> y
c -----------------------
c
      y(k,1) = amu(k,1)
      y(k,n) = amu(k,n)
c
c 1.1 Calcul de la matrice intermediaire
c --------------------------------------
c
      alfa(2) = 6.
      do i=3,n-1
        alfa(i) = 6.-1./alfa(i-1)
      enddo
c
c 1.2 Boucle montante (vecteur intermediaire stocke aussi dans y)
c ---------------------------------------------------------------
c
      y(k,2) = (8*amu(k,2)-amu(k,1))/6.
      do i = 3,n-2
        y(k,i) = (8*amu(k,i) - y(k,i-1))/alfa(i)
      enddo
      y(k,n-1) = (8*amu(k,n-1)-amu(k,n)-y(k,n-2))/alfa(n-1)
c
c 1.3 Boucle descendante
c ----------------------
      do i = n-2,2,-1
        y(k,i) = y(k,i) - y(k,i+1)/alfa(i)
      enddo
c
c 2.  Passage a z : valeurs aux demi-pas de temps
c -----------------------------------------------
c
      z(k,1) = (3*y(k,1)-y(k,2))/2.
      z(k,2*n+1) = (3*y(k,n)-y(k,n-1))/2.
c
      do i = 1,n
        z(k,2*i) = y(k,i)
      enddo
c
      do i = 1,n-1
        z(k,2*i+1) = (y(k,i) + y(k,i+1))/2.
      enddo
c
c 3. Verification
c ---------------
c
cc      do i = 2,n-1
cc        aleft = 6*y(k,i)+y(k,i-1)+y(k,i+1)
cc        aright = 8*amu(k,i)
cc        resid = aright - aleft
cc        print *, 'aleft, aright, resid '
cc     $           ,aleft, aright, resid
cc      enddo
c
      enddo    ! Fin de la boucle sur les niveaux
c
      return
      end
      subroutine Fmread(iunit,x,nz,nt)
      dimension x(nz,nt)
c
      character*4 string
c
      i1 = 1
c
c      Boucle sur les rangees correspondant aux diverses tranches de
c      pas de temps
c ---------------------------------------------------------------------
10    continue
      do i=1,10
        read(iunit,1000) string
1000    format (a4)
        print *, string
        if (string .eq. '.***') go to 20
      enddo
      go to 90
c
20    continue
      i2 = min(nt,i1+4)
      do ik = 1,nz
          read(iunit,*) k,(x(k,i),i=i1,i2)
          print *, k,(x(k,i),i=i1,i2)
      enddo
      if (i2 .ge. nt) go to 30
      i1 = i2+1
      go to 10
c --------------------fin de la boucle sur les rangees ----------------
c
30    continue
      print *, 'Nbre de pas de temps lus : ', i2
c
      return
c ====================================
c
90    print *, 'mauvais fichier ',iunit
      stop
c
      end
      SUBROUTINE rdgrads(itape,icompt,nl,ps,z,u,v,temp,q,p,ph)


      IMPLICIT none
      integer nl
      INTEGER itape
c
      real ps
      real p(nl),u(nl),v(nl),z(nl),q(nl),temp(nl),ph(nl)

c
      INTEGER i, k
c
      INTEGER icompt
c
      print *, 'nl ',nl
c
            icompt=icompt+1
            READ(itape,rec=icompt)ps
         do k=1,nl
            icompt=icompt+1
            READ(itape,rec=icompt)z(k)
         enddo
         do k=1,nl
            icompt=icompt+1
            READ(itape,rec=icompt)u(k)
         enddo
         do k=1,nl
            icompt=icompt+1
            READ(itape,rec=icompt)v(k)
         enddo
         do k=1,nl
            icompt=icompt+1
            READ(itape,rec=icompt)Temp(k)
         enddo
         do k=1,nl
            icompt=icompt+1             
            READ(itape,rec=icompt)Q(k)
          if (q(k).le.0. ) q(k)=1.e-06
         enddo
         do k=1,nl
            icompt=icompt+1 
            READ(itape,rec=icompt)P(k)
         enddo
         do k=1,nl
            icompt=icompt+1 
            READ(itape,rec=icompt)PH(k)
         enddo

c
c
      RETURN
      END

