      	PROGRAM forcing4munk
	IMPLICIT NONE
C===================================================================
C=       TRANSFORMATION DU FICHIER ASCII "FORCING-DATA" EN FICHIER =
C=         A ACCES DIRECT LISIBLE PAR MUNK ET GRADS                =
C===================================================================
c
c  Variables :
c  ----------
c   nl       : nombre de niveaux des donnees
c   7        : nombre de pas de temps de la future simulation
c   u_arm    : numero d'unite d'ecriture
c   z        : altitude
c   hTpot    : tendance de temperature potentielle
c   hQ       : tendance de rapport de melange
c   hw       : vitesse verticale
c   P        : pression
c
c   Parameters :
c   -----------
c   nl       : dimension de la grille
c   nbeuc    : nombre de pas de temps des donnees
c   ifrst    : nombre de duplicata du premier pas, ajoutes en tete
c
c
c
      character*5 string
      integer klon,u_arm
      parameter (klon=1,u_arm=33)
      integer nl,nl1
      integer nll,nbeuc,nbeucpf,nbeuc2,ifrst,ifrstp1
c      parameter (nll=100)
      parameter (nll=18,nl1=1)
      parameter (ifrst = 0, ifrstp1 = ifrst+1)
      parameter (nl=18,nbeuc=33,nbeucpf=nbeuc+ifrst,nbeuc2=18*nbeuc+1)
      integer icomp
      real z(nll),htpot(nll,nbeucpf),hQ(nll,nbeucpf)
     $    ,hw(nll,nbeucpf),pp(nll),hU(nll,nbeucpf),hV(nll,nbeucpf)
      real hTpot2(nll,nbeuc2),hQ2(nll,nbeuc2),hw2(nll,nbeuc2)
     $    ,hU2(nll,nbeuc2),hV2(nll,nbeuc2)
      integer i,j,k,kj,l
c=======================================
c declarations for spline interpolations
c=======================================
	REAL dt,dtfine
	REAL ymean(nbeuc),tmean(nbeuc)
	REAL y(0:nbeuc),y2(0:nbeuc),t(0:nbeuc)
	REAL yfine(0:nbeuc2-1),tfine(0:nbeuc2-1)
c=======================================
c declaration for the ground temperature
c=======================================
	REAL tg(nbeucpf)
	REAL tg2(nbeuc2)
c============================================
c declaration from the program read_layer.f 
c author: Francoise Guichard CNRM
c============================================
      integer nt,np,nvar2,nv
      parameter(NT=33,NP=18,NVAR2=18)  !JUL 97 subcase A
      real time(nt),      !Calenday day
     +     yy(nt),        !Year
     +     mo(nt),        !Month
     +     dd(nt),        !Day
     +     hh(nt),        !Hour
     +     mm(nt)         !Minutes
      real p(np)          !Pressure (mb)
      real d(nvar2,np,nt) !Multi-Layer fields as described below
c                         !-9999.0 is assigned to levels below the ground level

      character*50 var_name2(nvar2)
c     data var_name2/
c    +   'Temp_(K)',                        'H2O_Mixing_Ratio_(g/kg)',    
c    +   'u_wind_(m/s)',                    'v_wind_(m/s)',                
c    +   'omega_(mb/hour)',                 'Wind_Div_(1/s)',   
c    +   'Horizontal_Temp_Advec_(K/hour)', 'Vertical_T_Advec(K/hour)',
c    +   'Horizontal_q_Advec_(g/kg/hour)',  'Vertical_q_Advec(g/kg/hour)',
c    +   's(Dry_Static_Energy)(K)',         'Horizontal_s_Advec_(K/hour)',
c    +   'Vertical_s_Advec(K/hour)',        'ds/dt(K/hour)',       
c    +   'DT/dt(K/hour)',                   'dq/dt_(g/kg/hour)',   
c    +   'Q1_(k/hour)',                     'Q2_(K/hour)' / 

c All relevant variables represent area-means in a domain enclosed by the
c following 12 grids centered around the ARM Central Facility.
c (These 12 grids are boundary facilities, profiler stations and analysis grids)
c longitude
c   -97.2956     -98.3165     -99.0911     -99.3289     -99.2175     -98.5725
c   -97.5186     -96.5619     -95.8633     -95.5513     -95.6347     -96.3023
c latitude
c    38.3092      38.2207      37.6522      36.8885      36.0719      35.2734
c    34.9797      35.1246      35.6825      36.5223      37.3800      38.0408
c Central Facility
c     -97.4900     36.6100
c

      integer nvar
      parameter(NVAR=35)  !JUL 97 subcaseA
      real ddd(nvar,nt)
      character*50 var_name(nvar)
c      data var_name/
c     +     'Calday',          'Year',                  'Month',  
c     +     'Day',             'Hour',                  'Minute', 
c     +     'Prec(mm/hour)',   'LH_(upward_W/m2)',      'SH_(upward_W/m2)', 
c     +     'Area_Mean_Ps(mb)','Central_Facility_Ps(mb)', 'Ts_Air(C)', 
c     +     'Tg_Soil(C)',      'Sfc_Air_RH(%)',    'Srf_wind_speed(m/s)', 
c     +     'u_wind_(m/s)',    'v_wind(m/s)',      'Srf_Net_Dn_Rad(W/m2)', 
c     +     'TOA_LW_Up(W/m2)', 'TOA_SW_Dn(W/m2)',  'TOA_Ins(W/m2)',       
c     +     'GOES_Lowcld(%)',  'GOES_Midcld(%) ',   'GOES_Hghcld(%)',     
c     +     'GOES_Totcld(%)',  'Cld_Thickness(km)', 'Cld_Top_ht(km)',   
c     +     'MWR_Cld_liquid(cm)', 'd(Column_H2O)/dt_(mm/hour)',       
c     +     'Column_H2O_Advection_(mm/hour)','Srf_Evaporation_(mm/hour)',
c     +     'd(Column_Dry_Static_Energy)/dt_(W/m2)', 
c     +     'Column_Dry_Static_Energy_Advection_(W/m2)', 
c     +     'Column_Radiative_Heating_(W/m2)',        
c     +     'Column_Latent_heating_(W/m2)'/ 

c All relevant variables represent area-means in a domain enclosed by the
c following 12 grids centered around the ARM Central Facility.
c (These 12 grids are boundary facilities, profiler stations and analysis grids)
c longitude 
c   -97.2956     -98.3165     -99.0911     -99.3289     -99.2175     -98.5725
c   -97.5186     -96.5619     -95.8633     -95.5513     -95.6347     -96.3023
c latitude
c    38.3092      38.2207      37.6522      36.8885      36.0719      35.2734
c    34.9797      35.1246      35.6825      36.5223      37.3800      38.0408
c Central Facility
c     -97.4900     36.6100
 

      open(unit=1,file='surface_ca3a.dat',status='old')
      read(1,*)
      read(1,*)
      read(1,*)
      read(1,*)

      do i=1,nvar
       read(1,21)var_name(i)
       read(1,22)(ddd(i,j),j=1,nt)
       print *,'You have just read the ', i, ' th field d(nt) as :  '
       print *,'             ', var_name(i)
      enddo
 21    format(a50)
 22    format(5e15.7)
      close(unit=1)
    

c*********************************************
c READ ALL THE VARIABLES IN 3D array d(i,j,k)
c*********************************************

      open(unit=1,file='layer_ca3a.dat',status='old') ! subcase A
      read(1,*)
      read(1,*)
      read(1,*)
      read(1,*)
      read(1,*)
      read(1,12)p
      read(1,*)
      read(1,12)time
      read(1,*)
      read(1,12)yy
      read(1,*)
      read(1,12)mo
      read(1,*)
      read(1,12)dd
      read(1,*)
      read(1,12)hh
      read(1,*)
      read(1,12)mm
      read(1,*)
      read(1,*)nv

      print *, 'apres read : p(1) ',p(1)
      do i=1,nv
       read(1,11)var_name2(i)
       do j=1,np
        read(1,12)(d(i,j,k),k=1,nt)
       enddo
        print *,'You have just read the ', i, 'th field d(np,nt) as :'
        print *,'             ', var_name2(i)
      enddo
11    format(a50)
12    format(5e15.7)
      close(unit=1)

c
c the fields of interest are :
c
c field no 7+8 : udTx + v dT/dy + w dT/dz
c field no 9+10 : u dq/dx + v dq/dy + w dq/dz
c
	DO k=1,nl
	  DO l=1,nbeucpf
	    htpot(k,l)=d(7,k,l)+d(13,k,l)
	    hq(k,l)=d(9,k,l)+d(10,k,l) 
	  END DO
	END DO

	OPEN(20,status='unknown',file='htpot.data',form='unformatted')
	OPEN(23,status='unknown',file='hq.data',form='unformatted')
	WRITE(20) htpot
	WRITE(23) hq
	CLOSE(20)
	CLOSE(23)
	  

c*********************************************************************
c INTERPOLATE DATA ON TIME STEP OF THE PHYSICS by using cubic spline
C interpolation that conserves means
c*********************************************************************
	dt = 18.
	dtfine = 1.
	DO l=1,nbeucpf
	  tmean(l) = (l-0.5)*dt
	END DO
	DO l=0,nbeucpf
	  t(l) = l*dt
	END DO
	DO l=0,nbeuc2-1
	  tfine(l) = l*dtfine
	END DO
	
	DO k=1,nl
	  DO l=1,nbeucpf
	    ymean(l)=htpot(k,l)
	  END DO
	  CALL spline( ymean, y, y2, nbeucpf, t, dt )
	  DO l=0,nbeuc2-1
	    CALL splint( t, y, y2, nbeucpf, tfine(l), yfine(l) )
	    htpot2(k,l+1) = yfine(l)
	  END DO

	  DO l=1,nbeucpf
	     ymean(l) = hq(k,l)
	  END DO
	  CALL spline( ymean, y, y2, nbeucpf, t, dt )
	  DO l=0,nbeuc2-1
	    CALL splint( t, y, y2, nbeucpf, tfine(l), yfine(l) )
	    hq2(k,l+1) = yfine(l)
	  END DO
	END DO
c
c deal with the one-dimensional groud temperature
c------------------------------------------------
	DO l=1,nbeucpf
	   ymean(l) = ddd(13,l)
	END DO
	CALL spline( ymean, y, y2, nbeucpf, t, dt )
	DO l=0,nbeuc2-1
	  CALL splint( t, y, y2, nbeucpf, tfine(l), yfine(l) )
	  tg2(l+1)=yfine(l) + 273.15
	END DO

cc      OPEN(20,status='UNKNOWN',FILE='finehtpot.data',form='unformatted')
cc      OPEN(23,status='UNKNOWN',FILE='finehq.data',form='unformatted')
cc      OPEN(24,status='UNKNOWN',FILE='finetg.data',form='unformatted')
cc      WRITE(20) htpot2
cc      WRITE(23) hq2
cc      WRITE(24) tg2
cc      CLOSE(20)
cc      CLOSE(23)
cc      CLOSE(24)
	  
c******************************************************
c MAKE UNITS AND APPROPRIATE TRANSFORMATIONS 
c
c - transform pressure in height
c - transform temperature in potential temperature
c - change units for humidity tendency
c******************************************************

c
c	compute heights 
c	---------------
	do k=1,nl
	  z(k) = p(k)
	end do

      print *, 'apres z=p, p(1) ',p(1)    
c
c	convert K/hour in K/s
c	---------------------
	DO k=1,nl	
	 DO l=1,nbeuc2
 	  htpot2(k,l) = htpot2(k,l)/3600.
	 END DO
	END DO
c
      print *,' p(1), loop1 ',p(1)
c
c	convert g/kg/hour in kg/kg/s
c	----------------------------
	DO k=1,nl
	  DO l=1,nbeuc2
	    hq2(k,l) = hq2(k,l)/1000./3600.
	  END DO
	END DO
c
      print *,' p(1), loop2 ',p(1)
c
c
c
	DO k=1,nl
	  DO l=1,nbeuc2
	    hw2(k,l)=0.
	  END DO
	END DO
c
      print *,' p(1), loop3 ',p(1)

c**************************************************
c	write the direct access file 'forcing.dat'
c**************************************************
c
      OPEN(u_arm,file='forcing.dat',form='unformatted',
     .              access='direct',recl=klon*4)
c
      print *,' Ecriture '
      print *,' P(1) ',p(1)
      icomp=0
      DO i=1,nbeuc2
         DO k=1,nl
            icomp=icomp+1
            write(u_arm,rec=icomp)(z(k))
         END DO
         DO k=1,nl
            icomp=icomp+1
            write(u_arm,rec=icomp)(hTpot2(k,i))
         END DO
	 DO k=1,nl
	    icomp=icomp+1
	    write(u_arm,rec=icomp)(hQ2(k,i))
         END DO
	 DO k=1,nl
	    icomp=icomp+1
	    write(u_arm,rec=icomp)(hw2(k,i))
	 END DO
	 icomp=icomp+1
	 write(u_arm,rec=icomp)(tg2(i))
      END DO
	 DO k=1,nl
	    icomp=icomp+1
	    write(u_arm,rec=icomp)(u(k,i))
	 END DO
	 DO k=1,nl
	    icomp=icomp+1
	    write(u_arm,rec=icomp)(v(k,i))
	 END DO
      print *,' Ecriture terminee '
c
      CLOSE(u_arm)
c
      print *, ' Apres CLOSE'
      
c*********************************************************************
c 	write the control file associated to the above file for GRADS
c*********************************************************************
      OPEN(99,file='forcing.ctl',form='formatted')
      print *, 'apres OPEN 99'
          write(99,'("DSET ^forcing.dat")')
          write(99,'("UNDEF 1.0E+30")')
          write(99,'("TITLE HAPEX92 LS forcing")')
          write(99,'("XDEF 1 LEVELS 0.0")')
          write(99,'("YDEF 1 LEVELS 0.0")')
      print *, 'avant ZDEF, nl = ',nl
      print *, 'p(1) = ',p(1)
          write(99,'("ZDEF",1x,i2,2x,"LEVELS",/(4f10.3))')
     .                     nl ,(P(k),k=1,nl)
      print *, 'avant TDEF'
          write(99,'("TDEF",2x,i3,2x,"LINEAR",2x,
     .               "00Z26JUN1992  10MN")')
     .                nbeuc2
      print *, ' avant VARS'
          write(99,'("VARS        7")')
      print *, 'apres VARS'
          write(99,'("z      ",2x,i3,2x,"99",2x,
     .               "altitude")')(nl)
          write(99,'("hTpot      ",2x,i3,2x,"99",2x,
     .               "tendance temperature potentielle")')nl
          write(99,'("hQ      ",2x,i3,2x,"99",2x,
     .               "tendance du rapport de melange")')nl
          write(99,'("hW      ",2x,i3,2x,"99",2x,
     .               "tendesse vitesse verticale")')nl
          write(99,'("Tg      ",2x,i2,2x,"99",2x,
     .               "Ground temperature")')nl1
          write(99,'("U       ",2x,i3,2x,"99",2x,
     .               "vitesse zonale")')nl
          write(99,'("V       ",2x,i3,2x,"99",2x,
     .               "vitesse meridienne")')nl
          write(99,'("ENDVARS")')
      print *, 'apres ENDVARS'
      CLOSE(99)
      print *, 'apres CLOSE 99'
                          
      print*,'hello'
c
      stop
 999  print *,'erreur lecture des donnees ',string,kj
      STOP
      END


	SUBROUTINE spline(ymean, y, y2, n, x, dx)
	IMPLICIT NONE
C*****************************************************************
C	SUBROUTINE spline 
C
C	PURPOSE: given tabulated mean values ymean(i) of a function
C                y between x(i) and x(i+1), compute the corresponding
C                discrete values y(i) and y''(i) at points x(i) 
C                assuming natural cubing spline behavior over each
C                interval. Furthermore, the resulting function has
C                zero projection on the grid noise g(j) = (-1)**j
C
C	INPUT: 
C	  ymean(n) : mean values at the points x(i)+dx/2. 
C	   x(0:n)  : regularly spaced values
C             dx   : grid spacing between x(i+1) and x(i)
C
C	OUTPUT:
C          y(0:n)  : values at the points x(i)
C	  y2(0:n)  : second derivative of y at points x(i)
C
C AUTHOR: Remi Tailleux, LMD, 2 January 2001
C******************************************************************
	
	INTEGER n,nmax
	PARAMETER(nmax=1000)
	REAL ymean(n),y(0:n),y2(0:n),x(0:n)
	REAL y2beta(0:nmax)
	REAL beta(0:nmax),rhs(nmax)
	REAL gam(nmax),bet,co
	REAL dx
	REAL power1,power2
	INTEGER i,j
c
c	compute beta
c	------------
	power1 = 5.d0-dsqrt(24.d0)
	power2 = 5.d0+dsqrt(24.d0)
	write(*,*) 'powers=',power1,power2
	beta(0)=0.d0
	DO i=1,n
	  beta(i) = ymean(i) - beta(i-1)
	END DO
c
c	compute rhs for tridiagonal system
c	----------------------------------
	DO i=1,n-1
	  rhs(i) = 2*(beta(i+1)-2.*beta(i)+beta(i-1))/dx**2
	END DO
c
c	find y2beta by solving the tridiagonal system 
c	---------------------------------------------
	bet = 10.d0
	y2beta(1) = 12.*rhs(1)/bet
	DO j=2,n-1
	  gam(j)= 1.d0/bet
	  bet = 10.d0-gam(j)
	  y2beta(j) = (12.*rhs(j)-y2beta(j-1))/bet
	END DO
	y2beta(0)=0.d0
	y2beta(n)=0.d0
	DO j=n-2,1,-1
	  y2beta(j) = y2beta(j) - gam(j+1)*y2beta(j+1)
	END DO
c
c	find y by retriving the time grid noise
c	---------------------------------------
	co=0.d0
	DO j=0,n
	  co = co - (-1)**j*beta(j)
	END DO
	co = co/(n+1.)
c
c	compute y and and its second derivative
c	---------------------------------------
	DO j=0,n
	  y(j) = 2.*beta(j) + dx**2*y2beta(j)/12. + co*(-1)**j*
     &    ( 1.d0 + power1**j + power2**(j-n) )
	 y2(j) = y2beta(j) + 12.*co*(-1)**(j+1)/dx**2*
     &    (1.d0 - power1**j - power2**(j-n) )
	END DO
c
	RETURN
	END


	SUBROUTINE splint( xa, ya, y2a, n, x, y) 
	IMPLICIT NONE
C*****************************************************************
C SUBROUTINE splint
C
C PURPOSE: compute the value y = y(x) given the tabulated array
C          of values ya(0:n) and ya''(0:n) corresponding to the 
C          points xa(0:n)
C
C INPUT:
C   	x  : point at which the value y(x) is sought
C    xa(0:n) : array of values for x
C    ya(0:n) : array of values of y
C   y2a(0:n) : array of values for second derivative of y
C
C OUTPUT: 
C	y = y(x)
C
C AUTHOR: Remi Tailleux, LMD, 2 Januaray 2001
C****************************************************************
	INTEGER n
	REAL xa(0:n),ya(0:n),y2a(0:n)
	REAL x,y
	INTEGER k,khi,klo
	REAL a,b,h
	klo=0
	khi=n
C
1	CONTINUE
	IF (khi-klo.GT.1) THEN
	  k=(khi+klo)/2
	  IF(xa(k).GT.x) THEN
	     khi = k
	  ELSE 
	     klo = k
	  END IF
	GOTO 1
	END IF
	h = xa(khi)-xa(klo)
	IF( h.EQ.0.d0) PAUSE 'bad xa input in splint'
	a = (xa(khi)-x)/h
	b = (x-xa(klo))/h
	y = a*ya(klo) + b*ya(khi) +
     &          ((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.d0
C
	RETURN
	END






